package cn.ey.biz.module.system.service.category.v2;

import cn.ey.biz.common.pojo.PageResult;
import cn.ey.biz.module.system.api.category.dto.CategoryCodeExtraRespDTO;
import cn.ey.biz.module.system.controller.admin.category.vo.*;
import cn.ey.biz.module.system.dal.dataobject.category.CategoryDO;
import cn.ey.biz.module.system.dal.redis.RedisKeyConstants;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;

/**
 * 字典分类 Service 接口
 */
public interface CategoryV2Service {

    /**
     * 创建字典分类
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCategory(@Valid CategoryCreateReqVO createReqVO);

    /**
     * 更新字典分类
     *
     * @param updateReqVO 更新信息
     */
    void updateCategory(@Valid CategoryUpdateReqVO updateReqVO);

    /**
     * 删除字典分类
     *
     * @param id 编号
     */
    void deleteCategory(Long id);

    /**
     * 获得字典分类
     *
     * @param id 编号
     * @return 字典分类
     */
    CategoryDO getCategory(Long id);

    /**
     * 获得字典分类列表
     *
     * @param ids 编号
     * @return 字典分类列表
     */
    List<CategoryDO> getCategoryList(Collection<Long> ids);

    /**
     * 获得字典分类分页
     *
     * @param pageReqVO 分页查询
     * @return 字典分类分页
     */
    PageResult<CategoryRespVO> getCategoryPage(CategoryPageReqVO pageReqVO);

    /**
     * 获得字典分类列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 字典分类列表
     */
    List<CategoryDO> getCategoryList(CategoryExportReqVO exportReqVO);

    /**
     * 获得字典分类列表
     *
     * @param categoryCode 分类编码
     * @return 字典分类列表
     */
    CategoryDO getCategoryCacheable(String categoryCode);

    /**
     * 获得字典分类编码列表
     *
     * @return 字典分类编码列表
     */
    List<CategoryDO> getAllCategoryCodeList();

    /**
     * 获得字典分类列表, 用于 Excel 导出
     *
     * @param dictTable 字典表
     * @return 字典版本的缓存key
     */
    default String formatKey(String dictTable) {
        return String.format(RedisKeyConstants.DICT_VERSION.getKeyTemplate(), dictTable);
    }

    /**
     * 清除公共字典分类缓存
     */
    void resetCategoryCache();

    /**
     * 查询所有字典分类信息和额外信息
     */
    List<CategoryCodeExtraRespDTO> listCategoryCodeExtraInfo();
}
